package ocr

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/renzhengshouquan"
	"shylinux.com/x/community/src/renzhengshouquan/external/tencentcloud"

	"github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/common"
	sdk "github.com/tencentcloud/tencentcloud-sdk-go/tencentcloud/ocr/v20181119"
)

type ocr struct {
	tencentcloud.Tencentcloud
}

func (s ocr) List(m *ice.Message, arg ...string) {}

func (s ocr) BizLicense(m *ice.Message, arg ...string) {
	request := sdk.NewBizLicenseOCRRequest()
	request.ImageBase64 = common.StringPtr(s.ImageData(m, arg...))
	response, err := s.newClient(m).BizLicenseOCR(request)
	s.ParseResponse(m, response, err)
}
func (s ocr) IDCard(m *ice.Message, arg ...string) {
	request := sdk.NewIDCardOCRRequest()
	request.ImageBase64 = common.StringPtr(s.ImageData(m, arg...))
	response, err := s.newClient(m).IDCardOCR(request)
	s.ParseResponse(m, response, err)
}

func init() { ice.TeamCtxCmd(ocr{}) }

func (s ocr) newClient(m *ice.Message, arg ...string) *sdk.Client {
	c, _ := sdk.NewClient(s.NewCredential(m), "", s.NewProfile(m))
	return c
}

func init() { renzhengshouquan.OcrVendor = ocr{} }
